
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>第四章：4．2MySQL 权限系统介绍 / 憋错料</title>

    <meta name="description" content="第四章：4．2MySQL 权限系统介绍 4.2.1 权限系统简介 MySQL 的权限系统在实现上比较简单,相关权限信息主要存储在几个被称为granttables 的系统表中,即: mysql.User,mysql.db,mysql.Host,mysql.table_priv 和mysql.column_priv.由于权限信息数据量比较小,而且访问又非常频繁,所以Mysql 在启动的时候,就会将所有的权限信息都Load 到内存中保存在几个特定的结构中.所以才有我们每次手工修改了权限相关的表之后,都需要执行&quot;FLUSH PRIV ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">第四章：4．2MySQL 权限系统介绍</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><P><STRONG>4.2.1 权限系统简介</STRONG><BR>　　MySQL<br />
的权限系统在实现上比较简单，相关权限信息主要存储在几个被称为grant<BR>tables 的系统表中，即：<br />
mysql.User，mysql.db，mysql.Host，mysql.table_priv<br />
和<BR>mysql.column_priv。由于权限信息数据量比较小，而且访问又非常频繁，所以Mysql 在启<BR>动的时候，就会将所有的权限信息都Load<br />
到内存中保存在几个特定的结构中。所以才有我<BR>们每次手工修改了权限相关的表之后，都需要执行“FLUSH<br />
PRIVILEGES”命令重新加载MySQL<BR>的权限信息。当然，如果我们通过GRANT，REVOKE 或者DROP USER<br />
命令来修改相关权限，则<BR>不需要手工执行FLUSH PRIVILEGES 命令，因为通过GRANT，REVOKE 或者DROP USER<br />
命令所<BR>做的权限修改在修改系统表的同时也会更新内存结构中的权限信息。在MySQL5.0.2 或更高<BR>版本的时候，MySQL 还增加了CREATE<br />
USER 命令，以此创建无任何特别权限（仅拥有初始USAGE<BR>权限）的用户，通过CREATE USER<br />
命令创建新了新用户之后，新用户的信息也会自动更新到<BR>内存结构中。所以，建议读者一般情况下尽量使用GRANT，REVOKE，CREATE USER<br />
以及DROP<BR>USER 命令来进行用户和权限的变更操作，尽量减少直接修改grant tables 来实现用户和权<BR>限变更的操作。</p>
<p><STRONG>4.2.2 权限授予与去除</STRONG><BR>　　要为某个用户授权，可以使用GRANT<br />
命令，要去除某个用户已有的权限则使用REVOKE<BR>命令。当然，出了这两者之外还有一种比较暴力的办法，那就是直接更新grant tables<br />
系<BR>统表。当给某个用户授权的时候，不仅需要指定用户名，同时还要指定来访主机。如果在授<BR>权的时候仅指定用户名，则MySQL<br />
会自动认为是对‘username‘@‘%‘授权。要去除某个用户的<BR>的权限同样也需要指定来访主机。<BR>　　可能有些时候我们还会需要查看某个用户目前拥有的权限，这可以通过两个方式实现，<BR>首先是通过执行“SHOW<br />
GRANTS FOR ‘username‘@‘hostname‘” 命令来获取之前该用户身上<BR>的所有授权。另一种方法是查询grant tables<br />
里面的权限信息。</p>
<p>4.2.3 权限级别<BR>MySQL 中的权限分为五个级别，分别如下：<BR>1、Global Level：<BR>　　Global Level<br />
的权限控制又称为全局权限控制，所有权限信息都保存在mysql.user 表<BR>中。Global Level 的所有权限都是针对整个mysqld<br />
的，对所有的数据库下的所有表及所有<BR>字段都有效。如果一个权限是以Global Level<br />
来授予的，则会覆盖其他所有级别的相同权<BR>限设置。比如我们首先给abc 用户授权可以UPDATE 指定数据库如test 的t<br />
表，然后又在<BR>全局级别REVOKE 掉了abc 用户对所有数据库的所有表的UPDATE 权限。则这时候的abc 用户<BR>将不再拥有用对test.t<br />
表的更新权限。Global Level 主要有如下这些权限(见表4-1)：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9pLzQ2Njg0OS8yMDE0MDUvMDQwOTU4MjIzNDU3MjYxLnBuZw==.jpg"></p>
<p>　　要授予Global Level 的权限，则只需要在执行GRANT 命令的时候，用“*.*”来指定适<BR>用范围是Global<br />
的即可，当有多个权限需要授予的时候，也并不需要多次重复执行GRANT<BR>命令，只需要一次将所有需要的权限名称通过逗号（“,”）分隔开即可，如下：<BR>　　</p>
<p>　　[email&#160;protected] : mysql 05:14:35&gt; GRANT SELECT,UPDATE,DELETE,INSERT ON<br />
*.*<BR>TO ‘def‘@‘localhost‘;<BR>Query OK, 0 rows affected (0.00 sec)</p>
<p><P><STRONG>2、Database Level</STRONG></p>
<p>　　Database Level 是在Global Level 之下，其他三个Level<br />
之上的权限级别，其作用域<BR>即为所指定整个数据库中的所有对象。与Global Level 的权限相比，Database Level<br />
主要<BR>少了以下几个权限：CREATE USER，FILE，PROCESS，RELOAD，REPLICATION<br />
CLIENT，REPLICATION<BR>SLAVE，SHOW DATABASES，SHUTDOWN，SUPER 和USAGE<br />
这几个权限，没有增加任何权限。之<BR>前我们说过Global Level 的权限会覆盖底下其他四层的相同权限，Database Level<br />
也一样，<BR>虽然他自己可能会被Global Level 的权限设置所覆盖，但同时他也能覆盖比他更下层的<BR>Table，Column 和Routine<br />
这三层的权限。</p>
<p>如果要授予Database Level 的权限，则可以有两种实现方式：<BR>1、在执行GRANT<br />
命令的时候，通过“database.*”来限定权限作用域为database 整个<BR>数据库，如下：<BR>　　</p>
<p>　　[email&#160;protected] : mysql 06:06:26&gt; GRANT ALTER ON test.* TO<br />
‘def‘@‘localhost‘;<BR>Query OK, 0 rows affected (0.00 sec)<BR>[email&#160;protected] :<br />
test 06:12:45&gt; SHOW GRANTS FOR<br />
[email&#160;protected];<BR>+------------------------------------------------------------------+<BR>|<br />
Grants for [email&#160;protected]<br />
|<BR>+------------------------------------------------------------------+<BR>|<br />
GRANT SELECT, INSERT, UPDATE, DELETE ON *.* TO ‘def‘@‘localhost‘ |<BR>| GRANT<br />
ALTER ON `test`.* TO ‘def‘@‘localhost‘<br />
|<BR>+------------------------------------------------------------------+</p>
<p>2、先通过USE<br />
命令选定需要授权的数据库，然后通过“*”来限定作用域，这样授权的<BR>作用域实际上就是当前选定的整个数据库。<BR>　　[email&#160;protected] :<br />
mysql 06:14:05&gt; USE test;<BR>Database changed<BR>[email&#160;protected] : test<br />
06:13:10&gt; GRANT DROP ON * TO ‘def‘@‘localhost‘;<BR>Query OK, 0 rows affected<br />
(0.00 sec)<BR>[email&#160;protected] : test 06:15:26&gt; SHOW GRANTS FOR<br />
[email&#160;protected];<BR>+------------------------------------------------------------------+<BR>|<br />
Grants for [email&#160;protected]<br />
|<BR>+------------------------------------------------------------------+<BR>|<br />
GRANT SELECT, INSERT, UPDATE, DELETE ON *.* TO ‘def‘@‘localhost‘ |<BR>| GRANT<br />
DROP, ALTER ON `test`.* TO ‘def‘@‘localhost‘<br />
|<BR>+------------------------------------------------------------------+</p>
<p>　　在授予权限的时候，如果有相同的权限需要授予多个用户，我们也可以在授权语句中一<BR>次写上多个用户信息，通过逗号（,）分隔开就可以了，如下：<BR>[email&#160;protected]<br />
: mysql 05:22:32&gt; grant create on perf.*<br />
to<BR>‘abc‘@‘localhost‘,‘def‘@‘localhost‘;<BR>Query OK, 0 rows affected (0.00<br />
sec)<BR>[email&#160;protected] : mysql 05:22:46&gt; SHOW GRANTS FOR<br />
[email&#160;protected];<BR>+------------------------------------------------------------------+<BR>|<br />
Grants for [email&#160;protected]<br />
|<BR>+------------------------------------------------------------------+<BR>|<br />
GRANT SELECT, INSERT, UPDATE, DELETE ON *.* TO ‘def‘@‘localhost‘ |<BR>| GRANT<br />
DROP, ALTER ON `test`.* TO ‘def‘@‘localhost‘ |<BR>| GRANT CREATE ON `perf`.* TO<br />
‘def‘@‘localhost‘<br />
|<BR>+------------------------------------------------------------------<BR>+</p>
<p>3 rows in set (0.00 sec)<BR>[email&#160;protected] : mysql 05:23:13&gt; SHOW GRANTS<br />
FOR<br />
[email&#160;protected];<BR>+------------------------------------------------------------------+<BR>|<br />
Grants for [email&#160;protected]<br />
|<BR>+------------------------------------------------------------------+<BR>|<br />
GRANT CREATE ON `perf`.* TO ‘abc‘@‘localhost‘ |<BR>| GRANT SELECT ON `test`.* TO<br />
‘abc‘@‘localhost‘<br />
|<BR>+------------------------------------------------------------------+<BR>3<br />
rows in set (0.00 sec)</p>
<p>3、Table Level<BR>　　Database Level 之下就是Table Level 的权限了，Table Level<br />
的权限可以被Global<BR>Level 和Database Level 的权限所覆盖，同时也能覆盖Column Level 和Routine Level<br />
的<BR>权限。</p>
<p>　　Table Level 的权限作用范围是授权语句中所指定数据库的指定表。如可以通过如下语<BR>句给test 数据库的t1<br />
表授权：<BR>[email&#160;protected] : test 12:02:15&gt; GRANT INDEX ON test.t1<br />
TO<BR>‘abc‘@‘%.jianzhaoyang.com‘;<BR>Query OK, 0 rows affected, 1 warning (0.00<br />
sec)<BR>[email&#160;protected] : test 12:02:53&gt; SHOW GRANTS FOR<br />
‘abc‘@‘%.jianzhaoyang.com‘;<BR>+----------------------------------------------------------+<BR>|<br />
Grants for [email&#160;protected]*.jianzhaoyang.com<br />
|<BR>+----------------------------------------------------------+<BR>| GRANT<br />
USAGE ON *.* TO ‘abc‘@‘%.jianzhaoyang.com‘ |<BR>| GRANT INDEX ON `test`.`t1` TO<br />
‘abc‘@‘%.jianzhaoyang.com‘<br />
|<BR>+----------------------------------------------------------+</p>
<p>　　上面的授权语句在测试给test 数据库的t1 表授予Table Level<br />
的权限的同时，还测试<BR>了将权限授予含有通配符“%”的所有“.jianzhaoyang.com”主机。其中的USAGE<br />
权限是每<BR>个用户都有的最基本权限。<BR>　　Table Level<br />
的权限由于其作用域仅限于某个特定的表，所以权限种类也比较少，仅有<BR>ALTER，CREATE，DELETE，DROP，INDEX，INSERT，SELECT<br />
UPDATE 这八种权限。</p>
<p>4、Column Level<BR>　　Column Level<br />
的权限作用范围就更小了，仅仅是某个表的指定的某个（活某些）列。<BR>由于权限的覆盖原则，Column Level<br />
的权限同样可以被Global，Database，Table 这三个<BR>级别的权限中的相同级别所覆盖，而且由于Column Level<br />
所针对的权限和Routine Level<BR>的权限作用域没有重合部分，所以不会有覆盖与被覆盖的关系。针对Column Level<br />
级别的<BR>权限仅有INSERT，SELECT 和UPDATE 这三种。Column Level 的权限授权语句语法基本和Table<BR>Level<br />
差不多，只是需要在权限名称后面将需要授权的列名列表通过括号括起来，如下：<BR>　　　[email&#160;protected] : test 12:14:46&gt;<br />
GRANT SELECT(id,value) ON test.t2 TO<BR>‘abc‘@‘%.jianzhaoyang.com‘;<BR>Query OK,<br />
0 rows affected(0.00 sec)<BR>[email&#160;protected] : test 12:16:49&gt; SHOW GRANTS FOR<br />
‘abc‘@‘%.jianzhaoyang.com‘;<BR>+-----------------------------------------------------------------------+<BR>|<br />
Grants for [email&#160;protected]*.jianzhaoyang.com<br />
|<BR>+-----------------------------------------------------------------------+<BR>|<br />
GRANT USAGE ON *.* TO ‘abc‘@‘%.jianzhaoyang.com‘ |<BR>| GRANT SELECT (value, id)<br />
ON `test`.`t2` TO ‘abc‘@‘%.jianzhaoyang.com‘ |<BR>| GRANT INDEX ON `test`.`t1`<br />
TO ‘abc‘@‘%.jianzhaoyang.com‘<br />
|<BR>+-----------------------------------------------------------------------+</p>
<p>注意：当某个用户在向某个表插入（INSERT）数据的时候，如果该用户在该表中某列上<BR>面没有INSERT<br />
权限，则该列的数据将以默认值填充。这一点和很多其他的数据库都有一些<BR>区别，是MySQL 自己在SQL 上面所做的扩展。</p>
<p>5、Routine Level<BR>　　Routine Level 的权限主要只有EXECUTE 和ALTER ROUTINE<br />
两种，主要针对的对象是<BR>procedure 和function 这两种对象，在授予Routine Level<br />
权限的时候，需要指定数据库<BR>和相关对象，如：<BR>　　[email&#160;protected] : test 04:03:26&gt; GRANT EXECUTE<br />
ON test.p1 to<BR>　　‘abc‘@‘localhost‘;<BR>　　Query OK, 0 rows affected (0.00<br />
sec)<BR>除了上面几类权限之外，还有一个非常特殊的权限GRANT，拥有GRANT 权限的用户可以</p>
<p>　　除了上面几类权限之外，还有一个非常特殊的权限GRANT，拥有GRANT<br />
权限的用户可以<BR>将自身所拥有的任何权限全部授予其他任何用户，所以GRANT 权限是一个非常特殊也非常重<BR>要的权限。GRANT<br />
权限的授予方式也和其他任何权限都不太一样，通常都是通过在执行GRANT<BR>授权语句的时候在最后添加WITH GRANT OPTION 子句达到授予GRANT<br />
权限的目的。</p>
<p>　　此外，我们还可以通过GRANT ALL 语句授予某个Level 的所有可用权限给某个用户，<BR>如：<BR>[email&#160;protected] :<br />
test 04:15:48&gt; grant all on test.t5 to ‘abc‘;<BR>Query OK, 0 rows affected<br />
(0.00 sec)<BR>[email&#160;protected] : test 04:27:39&gt; grant all on perf.* to<br />
‘abc‘;<BR>Query OK, 0 rows affected (0.00 sec)<BR>[email&#160;protected] : test<br />
04:27:52&gt; show grants for<br />
‘abc‘;<BR>+--------------------------------------------------+<BR>| Grants for<br />
[email&#160;protected]% |<BR>+--------------------------------------------------+<BR>| GRANT USAGE<br />
ON *.* TO ‘abc‘@‘%‘ |<BR>| GRANT ALL PRIVILEGES ON `perf`.* TO ‘abc‘@‘%‘ |<BR>|<br />
GRANT ALL PRIVILEGES ON `test`.`t5` TO ‘abc‘@‘%‘<br />
|<BR>+--------------------------------------------------+</p>
<p>　　在以上五个Level 的权限中，Table、Column 和Routine<br />
三者在授权中所依赖（或者引<BR>用）的对象必须是已经存在的，而不像Database Level<br />
的权限授予，可以在当前不存在该<BR>数据库的时候就完成授权。</p>
<p><STRONG>4.2.4 MySQL访问控制实现原理</STRONG></p>
<p>　　MySQL 访问控制实际上由两个功能模块共同组成，从第一篇的第二章架构组成中可以看<BR>到，一个是负责“看守MySQL<br />
大门”的用户管理模块，另一个就是负责监控来访者每一个动<BR>作的访问控制模块。用户管理模块决定造访客人能否进门，而访问控制模块则决定每个客人<BR>进门能拿什么不能拿什么。下面是一张MySQL<br />
中实现访问控制的简单流程图(见图4-2)：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9pLzQ2Njg0OS8yMDE0MDUvMDQxMDI3NDE5NzAxNDcwLnBuZw==.jpg"></p>
<p>1、用户管理<BR>　　我们先看看用户管理模块是如何工作的。在MySQL<br />
中，用户访问控制部分的实现比较简<BR>单，所有授权用户都存放在一个系统表中：mysql.user，当然这个表不仅仅存放了授权用户<BR>的基本信息，还存放有部分细化的权限信息。用户管理模块需要使用的信息很少，主要就是<BR>Host，User，Password<br />
这三项，都在mysql.user 表中，如下：</p>
<p>[email&#160;protected] : (none) 12:35:04&gt; USE mysql;<BR>Database<br />
changed<BR>[email&#160;protected] : mysql 12:35:08&gt; DESC<br />
user;<BR>+---------------+--------------------+------+-----+---------+-------+<BR>|<br />
Field | Type | Null | Key | Default | Extra<br />
|<BR>+---------------+--------------------+------+-----+---------+-------+<BR>|<br />
Host | char(60) | NO | PRI | | |<BR>| User | char(16) | NO | PRI | | |<BR>|<br />
Password | char(41) | NO | | | |<BR>...<br />
...<BR>+---------------+--------------------+------+-----+---------+-------+</p>
<p>　　一个用户要想访问MySQL，至少需要提供上面列出的这三项数据，MySQL<br />
才能判断是否<BR>该让他“进门”。这三项实际上由量部分组成：访问者来源的主机名（或者主机IP<br />
地址信息）<BR>和访问者的来访“暗号”（登录用户名和登录密码），这两部分中的任何一个没有能够匹配上<BR>都无法让看守大门的用户管理模块乖乖开门。其中Host<br />
信息存放的是MySQL 允许所对应的<BR>User<br />
的信任主机，可以是某个具体的主机名（如：mytest）或域名（如：www.domain.com），<BR>也可以是以“%”来充当通配符的某个域名集合（如：%.domain.com）；也可以是一个具体的<BR>IP<br />
地址(如：1.2.3.4)，同样也可以是存在通配符的域名集合(如：1.2.3.%)；还可以用“%”<BR>来代表任何主机，就是不对访问者的主机做任何限制。如以下设置：<BR>[email&#160;protected]<br />
: mysql 01:18:12&gt; SELECT host,user,password FROM user ORDER BY<BR>user;</p>
<p>　　但是这里有一个比较特殊的访问限制，如果要通过localhost 访问的话，必须要有一条<BR>专门针对localhost<br />
的授权信息，即使不对任何主机做限制也不行。如下例所示，存在[email&#160;protected]%<BR>的用户设置，但是如果不使用-h 参数来访问，则登录会被拒绝，因为mysql<br />
在默认情况下<BR>会连接localhost：</p>
<p>[email&#160;protected]:~$ mysql -u def -p<BR>Enter password:<BR>ERROR 1045 (28000): Access<br />
denied for user ‘def‘@‘localhost‘ (using<BR>password: YES)</p>
<p>　　但是当通过-h 参数，明确指定了访问的主机地址之后就没问题了，如下：<BR>[email&#160;protected]:~$ mysql -u def -p -h<br />
127.0.0.1<BR>Enter password:<BR>Welcome to the MySQL monitor. Commands end with<br />
; or \g.<BR>Your MySQL connection id is 17<BR>Server version: 5.0.51a-log Source<br />
distribution<BR>Type ‘help;‘ or ‘\h‘ for help. Type ‘\c‘ to clear the<br />
buffer.<BR>[email&#160;protected] : (none) 01:26:04&gt;</p>
<p><P>　　如果我们有一条localhost 的访问授权则可以不使用-h 参数来指定登录host<br />
而连接默<BR>认的localhost：<BR>[email&#160;protected]:~$ mysql -u abc -p<BR>Enter password:<BR>Welcome<br />
to the MySQL monitor. Commands end with ; or \g.<BR>Your MySQL connection id is<br />
18<BR>Server version: 5.0.51a-log Source distribution<BR>Type ‘help;‘ or ‘\h‘<br />
for help. Type ‘\c‘ to clear the buffer.<BR>[email&#160;protected] : (none) 01:27:19&gt;<br />
exit<BR>Bye</p>
<p>　　如果MySQL 正在运行之中的时候，我们对系统做了权限调整，那调整之后的权限什么时<BR>候会生效呢？<BR>　　我们先了解何时MySQL<br />
存放于内存结构中的权限信息被更新：FLUSH PRIVILEGES 会强<BR>行让MySQL 更新Load 到内存中的权限信息；GRANT、REVOKE<br />
或者CREATE USER 和DROP USER<BR>操作会直接更新内存中俄权限信息；重启MySQL 会让MySQL 完全从grant tables<br />
中读取权<BR>限信息。</p>
<p>　　那内存结构中的权限信息更新之后对已经连接上的用户何时生效呢？<BR>　　对于Global Level<br />
的权限信息的修改，仅仅只有更改之后新建连接才会用到，对于已<BR>经连接上的session 并不会受到影响。而对于Database Level<br />
的权限信息的修改，只有当<BR>客户端请求执行了“USE<br />
database_name”命令之后，才会在重新校验中使用到新的权限信<BR>息。所以有些时候如果在做了比较紧急的Global 和Database<br />
这两个Level 的权限变更之后，<BR>可能需要通过“KILL”命令将已经连接在MySQL 中的session<br />
杀掉强迫他们重新连接以使<BR>用更新后的权限。对于Table Level 和Column Level 的权限，则会在下一次需要使用到该<BR>权限的Query<br />
被请求的时候生效，也就是说，对于应用来讲，这两个Level 的权限，更新之<BR>后立刻就生效了，而不会需要执行“KILL”命令。</p>
<p>2、访问控制<BR>　　当客户端连接通过用户管理模块的验证，可连接上MySQL Server 之后，就会发送各种<BR>Query 和Command<br />
给MySQL Server，以实现客户端应用的各种功能。当MySQL<br />
接收到客户<BR>端的请求之后，访问控制模块是需要校验该用户是否满足提交的请求所需要的权限。权限校<BR>验过程是从最大范围的权限往最小范围的权限开始依次校验所涉及到的每个对象的每个权<BR>限。</p>
<p>　　在验证所有所需权限的时候，MySQL 首先会查找存储在内存结构中的权限数据，首先查<BR>找Global Level 权限，如果所需权限在Global<br />
Level 都有定义（GRANT<br />
或者REVOKE），<BR>则完成权限校验（通过或者拒绝），如果没有找到所有权限的定义，则会继续往后查找<BR>Database Level<br />
权限，进行Global Level 未定义的所需权限的校验，如果仍然没有能够<BR>找到所有所需权限的定义，MySQL<br />
会继续往更小范围的权限定义域查找，也就是Table<BR>Level，最后则是Column Level 或者Routine Level。</p>
<p>　　下面我们就以客户端通过[email&#160;protected] 连接后请求如下Query 我为例：<BR>SELECT id,name FROM test.t4<br />
where status = ‘deleted‘;</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9pLzQ2Njg0OS8yMDE0MDUvMDQxMTEyMTk2NzMyOTkwLnBuZw==.jpg"></p>
<p><P>　　在前面我们了解到MySQL 的grant tables<br />
有mysql.user，mysql.db，mysql.host，<BR>mysql.table_priv 和mysql.column_priv<br />
这五个，我想出了mysql.host 之外的四个都是非<BR>常容易理解的，每一个表针对MySQL 中的一种逻辑对象，存放某一特定Level<br />
的权限，唯独<BR>mysql.host 稍有区别。我们现在就来看看mysql.host 权限表到底在MySQL<br />
的访问控制中充<BR>当了一个什么样的角色呢？</p>
<p>　　mysql.host在MySQL 访问控制模块中所实现的功能比较特殊，和其他几个grant tables<BR>不太一样。首先是mysql.host<br />
中的权限数据不是（也不能）通过GRANT 或者REVOKE 来授予<BR>或者去除，必须通过手工通过INSERT、UPDATE 和DELETE<br />
命令来修改其中的数据。其次是<BR>其中的权限数据无法单独生效，必须通过和mysql.db 权限表的数据一起才能生效。而且仅<BR>当mysql.db<br />
中存在不完整（某些场景下的特殊设置）的时候，才会促使访问控制模块再结<BR>合mysql.host<br />
中查找是否有相应的补充权限数据实现以达到权限校验的目的，就比如上图<BR>中所示。在mysql.db 中无法找到满足权限校验的所有条件的数据（db.User =<br />
‘abc‘ AND<BR>db.host = ‘localhost‘ AND db.Database_name = ‘test‘），则说明在mysql.db<br />
中无法完<BR>成权限校验，所以也不会直接就校验db.Select_priv 的值是否为‘Y‘。但是mysql.db 中有<BR>db.User = ‘abc‘<br />
AND db.Database_name = ‘test‘ AND db.host = ‘‘<br />
这样一条权限信息<BR>存在，大家可能注意到了这条权限信息中的db.host 中是空值，注意是空值而不是‘%‘这个<BR>通配符哦。当MySQL<br />
注意到有这样一条权限信息存在的时候，就该是mysql.host 中所存放<BR>的权限信息出场的时候了。这时候，MySQL 会检测mysql.host<br />
中是否存在满足如下条件的<BR>权限信息：host.Host = ‘localhost‘ AND host.Db =<br />
‘test‘。如果存在，则开始进行<BR>Select_priv 权限的校验。由于权限信息存在于mysql.db 和mysql.host<br />
两者之中，而且是<BR>两者信息合并才能满足要求，所以Select_priv 的校验也需要两表都为‘Y‘才能满足要求，<BR>通过校验。</p>
<p>　　我们已经清楚，MySQL<br />
的权限是授予“[email&#160;protected]”的，也就是说，至少需要<BR>用户名和主机名二者才能确定一个访问者的权限。又由于hostname<br />
可以是一个含有通配符<BR>的域名，也可以是一个含有通配符的IP<br />
地址段。那么如果同一个用户有两条权限信息，一<BR>条是针对特定域名的，另外一个是含有通配符的域名，而且前者属于后者包含。这时候MySQL<BR>如何来确定权限信息呢？实际上MySQL<br />
永远优先考虑更精确范围的权限。在MySQL 内部会按<BR>照username 和hostname 作一个排序，对于相同username 的权限，其host<br />
信息越接近访问<BR>者的来源host，则排序位置越靠前，则越早被校验使用到。而且，MySQL<br />
在权限校验过程中，<BR>只要找到匹配的权限之后，就不会再继续往后查找是否还有匹配的权限信息，而直接完成校<BR>验过程。</p>
<p>　　大家应该也看到了在mysql.user<br />
这个权限表中有max_questions，max_updates，<BR>max_connections，max_user_connections<br />
这四列，前面三列是从MySQL4.0.2<br />
版本才开始<BR>有的，其功能是对访问用户进行每小时所使用资源的限制，而最后的max_user_connections<BR>则是从MySQL5.0.3<br />
版本才开始有的，他和max_connections<br />
的区别是限制耽搁用户的连接<BR>总次数，而不是每小时的连接次数。而要使这四项限制生效，需要在创建用户或者给用户授<BR>权的时候加上以下四种子句：<BR>max_questions<br />
： WITH MAX_QUERIES_PER_HOUR n；<BR>max_updates ： WITH MAX_UPDATES_PER_HOUR<br />
n；<BR>max_connections ： WITH MAX_CONNECTIONS_PER_HOUR<br />
n；<BR>max_user_connections： MAX_USER_CONNECTIONS。<BR>四个子句可以同时使用，如：</p>
<p>“ WITH MAX_QUERIES_PER_HOUR 5000 MAX_CONNECTIONS_PER_HOUR<br />
10<BR>MAX_USER_CONNECTIONS 10000”。</p>
<p><P><STRONG>4．3MySQL 访问授权策略</STRONG></p>
<p>　　首先，需要了解来访主机。</p>
<p>通过使用具体的主机名和IP 地址来限定来访主机。</p>
<p>　　其次，了解用户需求。</p>
<p>了解用户相对该系统扮演什么角色，比如是只读的，还是读写兼用的等等。</p>
<p>　　再次，要为工作分类。</p>
<p>　　比如将执行备份工作、复制工作、常规应用访问、只读应用访问和日常管理<BR>工作分别分理出单独的特定帐户来授予各自所需权限。这样，既可以让安全风险尽量降低，<BR>也可以让同类同级别的相似权限合并在一起，不互相交织在一起。对于PROCESS，FILE<br />
和<BR>SUPER 这样的特殊权限，仅仅只有管理类帐号才需要，不应该授予其他非管理帐号。</p>
<p>　　最后，确保只有绝对必要者拥有GRANT OPTION 权限。<BR>之前在权限系统介绍的时候我们已经了解到GRANT OPTION<br />
权限的特殊性，和拥有该权<BR>限之后的潜在风险，所以在这里也就不再累述了。总之，为了安全考虑，拥有GRANT<br />
OPTION<BR>权限的用户越少越好，尽可能只让拥有超级权限的用户才拥有GRANT OPTION 权限。</p>
<p><STRONG>4．4 安全设置注意事项</STRONG></p>
<p>仅仅提供本地访问，禁止网络服务，</p>
<p>启动MySQL的时候通过使用“--skip-networking”参数选项，让MySQL 不通过TCP/IP<br />
监听网络请求，<BR>而仅仅通过命名管道或共享内存(在Windows 中)或Unix 套接字文件(在Unix 中)来和客户端<BR>连接交互。</p>
<p>其次，在第二层防线主机上面也有以下一些需要注意的地方。</p>
<p>OS 安全方面。关闭MySQL Server<br />
主机上面任何不需要的服务，这不仅能从安全方面减<BR>少潜在隐患，还能减轻主机的部分负担，尽可能提高性能。</p>
<p>　　用非root 用户运行MySQL。这在MySQL 官方文档中也有非常明显的提示，提醒用户不<BR>要使用root<br />
用户来运行MySQL。因为如果使用root 用户运行MySQL，那么mysqld 的进程就<BR>会拥有root 用户所拥有的权限，任何具有FILE<br />
权限的MySQL 用户就可以在MySQL 中向系统<BR>中的任何位置写入文件。</p>
<p>　　文件和进程安全。合理设置文件的权限属性，MySQL<br />
相关的数据和日志文件和所在的文<BR>件夹属主和所属组都设置为mysql，且禁用其他所有用户（除了拥有超级权限的用户，如<BR>root）的读写权限。以防止数据或者日志文件被窃取或破坏。因为如果一个用户对MySQL<BR>的数据文件有读取权限的话，可以很容易将数据复制。binlog<br />
文件也很容易还原整个数据<BR>库。而如果有写权限的话就更糟了，因为有了写权限，数据或者日志文件就有被破坏或者删<BR>除的风险存在。保护好socket<br />
文件的安全，尽量不要使用默认的位置（如/tmp/mysql.sock），<BR>以防止被有意或无意的删除。</p>
<p>　　再次，就是最后第三道防线MySQL 自身方面的安全设置注意事项。</p>
<p>用户设置。我们必须确保任何可以访问数据库的用户都有一个比较复杂的内容作为密<BR>码，而不是非常简单或者比较有规律的字符，以防止被使用字典破解程序攻破。在MySQL<BR>初始安装完成之后，系统中可能存在一个不需要任何密码的root<br />
用户，有些版本安装完成<BR>之后还会存在一个可以通过localhost<br />
登录的没有用户名和密码的帐号。这些帐号会给系统<BR>带来极大的安全隐患，所以我们必须在正式启用之前尽早删除，或者设置一个比较安全的密<BR>码。对于密码数据的存放，也不要存放在简单的文本文件之中，而应该使用专业密码管理软<BR>件来管理（如KeePass）。同时，就像之前在网络安全注意事项部分讲到的那样，尽可能为<BR>每一个帐户限定一定范围的可访问主机。尤其是拥有超级权限的MySQL<br />
root 帐号，尽量确<BR>保只能通过localhost 访问。</p>
<p>安全参数</p>
<p>　　在MySQL<br />
官方参考手册中也有说明，不论是从安全方面考虑还是从性能以及<BR>功能稳定性方面考虑，不需要使用的功能模块尽量都不要启用。例如，如果不需要使用用户<BR>自定义函数，就不要在启动的时候使用“--allow-suspicious-udfs”参数选项，以防止被<BR>别有居心的潜在威胁者利用此功能而对MySQL<br />
的安全造成威胁；不需要从本地文件中Load<BR>数据到数据库中，就使用“--local-infile=0”禁用掉可以从客户端机器上Load<br />
文件到数<BR>据库中；使用新的密码规则和校验规则（不要使用“--old-passwords”启动数据库），这项<BR>功能是为了兼容旧版本的密码校验方式的，如无额数必要，不要使用该功能，旧版本的密码<BR>加密方式要比新的方式在安全方面弱很多。</p>
<p>　　除了以上这三道防线，我们还应该让连接MySQL<br />
数据库的应用程序足够安全，以防止入<BR>侵者通过应用程序中的漏洞而入侵到应用服务器，最终通过应用程序中的数据库相关关配置<BR>而获取数据库的登录口令。</p>
<p><A href="http://www.bubuko.com/infodetail-163523.html" rel="external nofollow noreferrer">第四章：4．2MySQL 权限系统介绍,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-01 21:13:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/des/" title="des">des</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/ext/" title="ext">ext</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/strong/" title="strong">strong</a>, <a href="https://www.biecuoliao.com/tag/2014/" title="2014">2014</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>第四章：4．2MySQL 权限系统介绍的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/E3wVeN0.html" rel="bookmark">linux第四章实验报告</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux第四章 用户和文件权限管理 实验环境 公司的linux主机即将提供给技术部作为开发服务器使用,根据部门内项目组的构成情况,首先需要建立相应的组账号.用户账号,并作为目录设置权限,还需要设置一个共用的数据存储目录,便于同事之间的数据交换. 需求描述 1.建立用户目录 创建目录/tech/benet和/tech/accp,分别用于存放各项目组中用户账号的宿主文件夹.例如,kylin用户的宿主目录应位于/tech/benet/kylin. 2.添加组账户 为两个项目组添加组账号benet,a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4JjKRV4.html" rel="bookmark">深入浅出Zabbix 3&period;0 -- 第四章  主机、用户和权限管理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第四章  主机.用户和权限管理 Zabbix中主机作为一个管理单元,用来管理和组织监控项,它可以包含任意数量和类型的监控项,并且每个主机必须属于至少一个主机组.当主机中的监控项获取监控数据后,Zabbix中创建的用户就可以访问这些数据,同样这些用户必须属于至少一个用户组.你可能注意到不管是主机还是用户,在Zabbix中必须属于至少一个主机组或用户组.为什么要这么做呢?这是因为Zabbix中是通过用户组和主机组来实现用户对主机中监控数据进行访问权限的分配和管理. 4.1主机 4.1.1创建主机 Z			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mobd8k4.html" rel="bookmark">2015年下半年软考中高级学员精讲班 &amp;nbsp&semi;  第四章</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2015年下半年软考中高级学员精讲班 主讲:王老师 中级学员和高级学员一起看中级教程 中级教程第四章 项目管理一般知识(P135-183) 中高级学员上午考试:3分选择题    下午考试:不考 高级学员本周重点是4.4节 上半年试题(19) ●矩阵型组织的缺点不包括(19). A. 管理成本增加                B. 员工缺乏事业上的连续性和保障 C. 多头领导                     D. 资源分配与项目优先的问题产生冲突 试题分析:矩阵型组织存在着管理成本增加.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pGkBJ3.html" rel="bookmark">第四章读书笔记 进程调度</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第四章读书笔记 进程调度 什么是进程调度 现在的操作系统都是多任务的,为了能让更多的任务能同时在系统上更好的运行,需要一个管理程序来管理计算机上同时运行的各个任务(也就是进程). 这个管理程序就是调度程序,它的功能说起来很简单: 决定哪些进程运行,哪些进程等待 决定每个进程运行多长时间 此外,为了获得更好的用户体验,运行中的进程还可以立即被其他更紧急的进程打断. 总之,调度是一个平衡的过程.一方面,它要保证各个运行的进程能够最大限度的使用CPU(即尽量少的切换进程,进程切换过多,CPU的时间会浪			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jyrK9M.html" rel="bookmark">第四章 初步进入linux世界</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第四章 初步进入linux世界 [Linux 系统启动过程] Linux的启动其实和windows的启动过程很类似,不过windows我们是无法看到启动信息的,而linux启动时我们会看到许多启动信息,例如某个服务是否启动. Linux系统的启动过程大体上可分为五部分:内核的引导:运行init:系统初始化:建立终端 :用户登录系统. A 内核引导 当计算机打开电源后,首先是BIOS开机自检,按照BIOS中设置的启动设备(通常是硬盘)来启动.紧接着由启动设备上的grub程序开始引导linux,当引			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgL9an0.html" rel="bookmark">Java学习笔记&mdash;第四章</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第四章  变量和常量 1. Java的访问控制修饰符 使用访问控制修饰符可以限制数据的访问权限.访问控制修饰符有4个等级:private.protected.    public和默认(不指定修饰符). 类型/权限 private protected public 默认 所属类 可访问 可访问 可访问 可访问 同一个包中的其他类(包括子类) 不可访问 可访问 可访问 可访问 不同包中的子类 不可访问 可访问 可访问 不可访问 不同包中的非子类 不可访问 不可访问 可访问 不可访问 2. 变量:变			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0K2zLyM.html" rel="bookmark">java-第四章-switch 判断分数奖励物品</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近发现MDT推出去的系统的有不同问题,其问题就不说了,主要是策略权限被域继承了.比如我们手动安装的很多东东都是未配置壮态,推的就默认为安全壮态了,今天细找了一下,原来把这个关了就可以了. java-第四章-switch 判断分数奖励物品,布布扣,bubuko.com			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bYxlYM.html" rel="bookmark">java-第四章-switch 淡旺季机票的售价问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近发现MDT推出去的系统的有不同问题,其问题就不说了,主要是策略权限被域继承了.比如我们手动安装的很多东东都是未配置壮态,推的就默认为安全壮态了,今天细找了一下,原来把这个关了就可以了. java-第四章-switch 淡旺季机票的售价问题,布布扣,bubuko.com			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0l5mNB3.html" rel="bookmark">一到四章心得</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第一章第一章主要对Android系统移植与驱动开发进行了简单的概述,明白了为某些特定设备定制Android系统的过程就叫做移植.第一节回顾了Android系统4层架构的详细知识,我倒是还记得一些:第二节介绍了Android系统移植的主要工作,Android移植可分为两部分:应用移植和系统移植.在此详细阐述了系统移植的方法及原因,主要工作为:移植linux驱动和移植HAL:第三节介绍了两种查看linux内核的方法:第四节介绍了linux内核版本号的定义规则,一个完整的内核版本号由5部分组成:主版本			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0n1RxM.html" rel="bookmark" class="title">IDEA使用01 创建java项目、创建web项目</a>
					<div>
						注意:本教程使用的开发环境是:(专业版) 1 创建javaSE项目 1.1 file -&gt; new -&gt; project 注意:如果是第一次使用,就需要配置 project SDK  ,  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVgDQ20.html" rel="bookmark" class="title">最终给WinEdt跪了</a>
					<div>
						两个业余的晚上折腾WinEdt,跪了,彻底跪了.居然不能自定义一整套theme,然后在需要的时候能够变来变去.结果需要从亮色主题变成暗色主题时,居然需要提着键盘鼠标从Background Scheme ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wrpwZ0.html" rel="bookmark" class="title">Java transient关键字使用小记</a>
					<div>
						1. transient的作用及使用方法 我们都知道一个对象只要实现了Serilizable接口,这个对象就可以被序列化,java的这种序列化模式为开发者提供了很多便利,我们可以不必关系具体序列化的过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kXEQp3.html" rel="bookmark" class="title">数独游戏的设计与实现</a>
					<div>
						前景:数独游戏,是一种数学智力拼图游戏,是“独立的数字游戏”的简称,源自18世纪末的瑞士,后在美国发展,在日本得以发扬光大. 数独游戏可以训练玩家的逻辑推理能力,不少教育者皆认为数独是锻炼脑筋的好方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0enzOb3.html" rel="bookmark" class="title">03 Java面向对象基本特征</a>
					<div>
						作者:thoughtInShare 出处:http://www.cnblogs.com/thoughtInShare 欢迎转载,也请保留这段声明.谢谢! 1,Java设计的基本思想是使用类,对象,继承 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz5O8k4.html" rel="bookmark" class="title">Delphi 中字符串资源的定义与使用</a>
					<div>
						字符串的存储在应用程序中是独立的,应用程序只有在使用资源时载入,使用完之后清除,从而节省内存,同时字符串也可以用于翻译,一些汉化软件都利用了字符串.编辑的字符串放在一个文本文件中,可以使用Delphi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NzO8Z4.html" rel="bookmark" class="title">Linux DNS （2）搭建DNS服务器</a>
					<div>
						注意:实验很简单,环境很重要.大家在做实验的时候一定要注意环境的配置,不然实验做的再好最后的结果也和我们想的要的结果不一样的. 首先我们先准备环境: 虚拟机一个 RedHat5.9系统两个操作系统 我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wyzJlM.html" rel="bookmark" class="title">C&num;面试题汇总（不断更新）</a>
					<div>
						1.XmlSerializer是如何工作的?使用这个类的进程需要什么ACL权限? 答:将对象序列化成为xml数据,反序列化再将xml转换成对象.应该至少需要ACL权限中的读权限. 2.Debug Bu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bOrNv3.html" rel="bookmark" class="title">在ViewController中View的生命周期</a>
					<div>
						view的生命周期如下(按顺序) -(void)loadView 用代码初始化的时候,第一个调用该方法.可以在这里面addSubView. -(void)viewDidLoad 初始化时一些数据的设置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KZrwwM.html" rel="bookmark" class="title">shell脚本编程（1）</a>
					<div>
						1.什么是shell脚本 shell是一个命令行解释器,它的作用就是遵循一定的语法将输入的命令加以解释并传给系统.它为用户提供了一个向Linux发送请求以便运行程序的接口系统级程序,shell本身是一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7OJq3.html" rel="bookmark" class="title">Linux安装ElasticSearch与MongoDB分布式集群环境下数据同步</a>
					<div>
						ElasticSearch有一个叫做river的插件式模块,可以将外部数据源中的数据导入elasticsearch并在上面建立索引.River在集群上是单例模式的,它被自动分配到一个节点上,当这个节点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0doaBBM.html" rel="bookmark" class="title">结对编程任务的算法流程思路</a>
					<div>
						这次的结对编程的作业相较于上次的作业看似只是核心功能的嫁接过程,但是程序这个东西尤其是对于实战经验并不很足的我来讲,其实还是很有难度的,因为在这次的作业要求中新加了很多的可以由用户定制的功能要求,那么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD8z79M.html" rel="bookmark" class="title">OSPF详解之三：OSPF LSA详解</a>
					<div>
						OSPF LSA详解 OSPF V2版本中常用的主要有6类LSA,分别是Router-LSA.Network-LSA.Network-summary-LSA.ASBR-summary-LSA.AS-E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Jv7Lb4.html" rel="bookmark" class="title">Yii中查询数据</a>
					<div>
						User::find()-&gt;all(); 此方法返回所有数据: User::findOne($id); 此方法返回 主键 id=1 的一条数据(举个例子): User::find()-&gt;w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzB8a2M.html" rel="bookmark" class="title">运用把不同的方式排版，涉及到float box-flox box-orient</a>
					<div>
						1.div+CSS 使用float属性 2.box-orient制作的上中下,中间分三栏(首栏和底栏宽度值相同,中间栏宽度的值略小于首栏才可以无缝对接) 3.使用了box-flex属性 4.垂直分布  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJxD63.html" rel="bookmark" class="title">AndroidManifest&period;xml文件详解（uses-permission）</a>
					<div>
						语法(SYNTAX): &lt;uses-permissionandroid:name=&quot;string&quot;/&gt; 被包含于(CONTAINED IN): &lt;manifest ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41wdzO0.html" rel="bookmark" class="title">2016第八届郑州&amp;&num;183&semi;孕婴童产品博览会</a>
					<div>
						2016第八届郑州·孕婴童产品博览会2016第二届中华幼教用品暨玩具游乐设备展览会展览日期:2016年5月20-22日 展览地点:郑州国际会展中心展览周期:每年一届 展览规模:20000平米 一.展会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0b5vepM.html" rel="bookmark" class="title">Java程序员笔试面试之String</a>
					<div>
						1.如何实现字符串的反转例如:&quot;how are you&quot;---&gt;&quot;you are how&quot; 2.如何判断2个字符串是否有相同的字符组成 例如&quot;a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qOEqGM.html" rel="bookmark" class="title">Eclipse添加JPDL4 Schema校验</a>
					<div>
						由于jbpm官方提供的图形化流程设计器(GPD)功能并不是特别的全面,很多设计并不能全在图形界面下完成.因此,在很多情况下,我们需要直接编辑JPDL的XML源代码,所以, 最好为JPDL XML指定S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBj9BAM.html" rel="bookmark" class="title">AutoLayout--masonry使用</a>
					<div>
						[label1 mas_makeConstraints:^(MASConstraintMaker *make) { //使左边间距为 make.left.equalTo(self.view.mas_l ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
